/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160108-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt2.dat, Tue Jan 31 15:07:18 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001E3D (7741)
 *     Revision         0x01
 *     Checksum         0x85
 *     OEM ID           "AmdRef"
 *     OEM Table ID     "AmdTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */
DefinitionBlock ("ssdt2.aml", "SSDT", 1, "AmdRef", "AmdTabl", 0x00001000)
{
    /*
     * iASL Warning: There were 9 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.PCI0.GFX0.AINT, MethodObj)    // Warning: Unresolved method, guessing 2 arguments
    External (_SB_.PCI0.GFX0.GHDS, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (_SB_.PCI0.GFX0.GLID, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (_SB_.PCI0.LPCB.EC0_.CPOL, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (AMDA, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (ASLB, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (EBAS, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (LIDS, MethodObj)    // Warning: Unresolved method, guessing 0 arguments
    External (PEBS, MethodObj)    // Warning: Unresolved method, guessing 1 arguments

    External (_SB_.LID0._LID, UnknownObj)
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.BAT1.POFT, UnknownObj)
    External (_SB_.PCI0.GFX0, DeviceObj)
    External (_SB_.PCI0.GFX0._DOD, IntObj)
    External (_SB_.PCI0.GFX0.CLID, UnknownObj)
    External (_SB_.PCI0.GFX0.DD01._ADR, IntObj)
    External (_SB_.PCI0.GFX0.DD02._ADR, IntObj)
    External (_SB_.PCI0.GFX0.DD02._BCL, IntObj)
    External (_SB_.PCI0.GFX0.DD02._BCM, IntObj)
    External (_SB_.PCI0.GFX0.DD02._BQC, IntObj)
    External (_SB_.PCI0.GFX0.DD03._ADR, IntObj)
    External (_SB_.PCI0.GFX0.DD04._ADR, IntObj)
    External (_SB_.PCI0.GFX0.DD05._ADR, IntObj)
    External (_SB_.PCI0.GFX0.DD06._ADR, IntObj)
    External (_SB_.PCI0.GFX0.DD07._ADR, IntObj)
    External (_SB_.PCI0.GFX0.DD08._ADR, IntObj)
    External (_SB_.PCI0.LPCB.EC0_.DGPU, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.FLAG, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.PSBB, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.PSTA, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.QEVN, UnknownObj)
    External (_SB_.PCI0.LPCB.H_EC.SCAN, UnknownObj)
    External (_SB_.PCI0.P0P2, DeviceObj)
    External (_SB_.PCI0.P0P2.PEGP, DeviceObj)
    External (_SB_.PCI0.P0P2.PEGP._ADR, UnknownObj)
    External (_SB_.PCI0.WMID.BAEF, UnknownObj)
    External (CMSD, IntObj)
    External (CMSI, UnknownObj)
    External (DID1, UnknownObj)
    External (DID2, UnknownObj)
    External (DID3, UnknownObj)
    External (DID4, UnknownObj)
    External (DID5, UnknownObj)
    External (DID6, UnknownObj)
    External (DID7, UnknownObj)
    External (DSEN, UnknownObj)
    External (NDID, UnknownObj)
    External (PWRS, IntObj)

    Scope (\_SB.PCI0.P0P2.PEGP)
    {
        OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
            Offset (0x0C), 
            Offset (0x0E), 
            PO16,   1, 
            PI17,   1, 
            Offset (0x38), 
                ,   3, 
            PO35,   1, 
            PO36,   1, 
            PI37,   1, 
                ,   14, 
            PO52,   1, 
            PO53,   1, 
            Offset (0x48), 
                ,   3, 
            PO67,   1
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
        {
            Local0 = (Arg2 & 0xFF)
            If ((Arg0 == ToUUID ("7ed873d3-c2d0-4e4f-a854-0f1317b01c2c")))
            {
                If ((Arg2 == Zero))
                {
                    Return (Unicode ("\x03"))
                }

                If ((Arg2 == One))
                {
                    Return (Package (0x08)
                    {
                        0x07, 
                        Package (0x02)
                        {
                            0x80010100, 
                            Buffer (0x04)
                            {
                                 0x01, 0x03, 0x03, 0x00                           /* .... */
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010400, 
                            Buffer (0x04)
                            {
                                 0x02, 0x03, 0x03, 0x00                           /* .... */
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010300, 
                            Buffer (0x04)
                            {
                                 0x08, 0x03, 0x03, 0x03                           /* .... */
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010301, 
                            Buffer (0x04)
                            {
                                 0x04, 0x03, 0x03, 0x03                           /* .... */
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010302, 
                            Buffer (0x04)
                            {
                                 0x05, 0x03, 0x03, 0x03                           /* .... */
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010303, 
                            Buffer (0x04)
                            {
                                 0x0A, 0x03, 0x03, 0x03                           /* .... */
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010304, 
                            Buffer (0x04)
                            {
                                 0x06, 0x03, 0x03, 0x03                           /* .... */
                            }
                        }
                    })
                }

                Return (One)
            }

            Return (One)
        }

        OperationRegion (APXM, SystemMemory, AMDA (0x00010400), Field (APXM, AnyAcc, NoLock, Preserve)
            {
                APSG,   128, 
                APSZ,   32, 
                APVR,   32, 
                Offset (0x100), 
                APXA,   32, 
                RVBS,   32, 
                TVBO,   32, 
                PXEN,   8, 
                Offset (0x180), 
                NTLE,   16, 
                TLE1,   16, 
                TLE2,   16, 
                TLE3,   16, 
                TLE4,   16, 
                TLE5,   16, 
                TLE6,   16, 
                TLE7,   16, 
                TLE8,   16, 
                TLE9,   16, 
                TL10,   16, 
                TL11,   16, 
                TL12,   16, 
                TL13,   16, 
                TL14,   16, 
                TL15,   16, 
                Offset (0x200), 
                TGXA,   16, 
                AGXA,   16, 
                GSTP,   8, 
                Offset (0x210), 
                DSWR,   8, 
                EMDR,   8, 
                TSTR,   8, 
                FPSR,   8, 
                SPSR,   8, 
                DCFR,   8, 
                Offset (0x230), 
                TSTG,   8, 
                TSSI,   8, 
                FPTG,   8, 
                FPSI,   8, 
                SPWS,   8, 
                Offset (0x250), 
                SUPD,   16, 
                CACD,   16, 
                CCND,   16, 
                NACD,   16, 
                TLST,   8, 
                LDST,   8, 
                Offset (0x3C0), 
                TVSD,   8, 
                EXPM,   8, 
                BPSD,   16, 
                BSPD,   16, 
                TLSN,   16, 
                Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
        Method (ATPX, 2, Serialized)
        {
            If ((Arg0 == Zero))
            {
                Name (TMP1, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP1, Zero, F0SS)
                CreateWordField (TMP1, 0x02, F0IV)
                CreateDWordField (TMP1, 0x04, F0SF)
                F0SS = 0x08
                F0IV = One
                F0SF = 0xBF
                Return (TMP1) /* \_SB_.PCI0.GFX0.ATPX.TMP1 */
            }

            If ((Arg0 == One))
            {
                Name (TMP2, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP2, Zero, F1SS)
                CreateDWordField (TMP2, 0x02, F1VM)
                CreateDWordField (TMP2, 0x06, F1FG)
                F1SS = 0x0A
                F1VM = 0x40
                F1FG = 0x40
                Return (TMP2) /* \_SB_.PCI0.GFX0.ATPX.TMP2 */
            }

            If ((Arg0 == 0x02))
            {
                CreateWordField (Arg1, Zero, FN2S)
                CreateByteField (Arg1, 0x02, DGPR)
                If ((DGPR == Zero))
                {
                    \_SB.PCI0.P0P2.PEGP._OFF ()
                    \_SB.PCI0.LPCB.EC0.DGPU = Zero
                }

                If ((DGPR == One))
                {
                    \_SB.PCI0.P0P2.PEGP._ON ()
                    \_SB.PCI0.LPCB.EC0.DGPU = One
                }

                Return (Zero)
            }

            If ((Arg0 == 0x03))
            {
                CreateWordField (Arg1, Zero, FN3S)
                CreateWordField (Arg1, 0x02, SDMG)
                If ((SDMG == Zero))
                {
                    If (Zero)
                    {
                        \_SB.PCI0.P0P2.PEGP.PO52 = Zero
                        Sleep (0x01F4)
                    }
                    Else
                    {
                        \_SB.PCI0.P0P2.PEGP.PO52 = One
                    }
                }

                If ((SDMG == One))
                {
                    If (Ones)
                    {
                        \_SB.PCI0.P0P2.PEGP.PO52 = Zero
                        Sleep (0x01F4)
                    }
                    Else
                    {
                        \_SB.PCI0.P0P2.PEGP.PO52 = One
                    }
                }

                Return (Zero)
            }

            If ((Arg0 == 0x04))
            {
                CreateWordField (Arg1, Zero, FN4S)
                CreateWordField (Arg1, 0x02, SIMG)
                If ((SIMG == Zero))
                {
                    If (Zero)
                    {
                        \_SB.PCI0.P0P2.PEGP.PO67 = Zero
                    }
                    Else
                    {
                        \_SB.PCI0.P0P2.PEGP.PO67 = One
                    }
                }

                If ((SIMG == One))
                {
                    If (Ones)
                    {
                        \_SB.PCI0.P0P2.PEGP.PO67 = Zero
                    }
                    Else
                    {
                        \_SB.PCI0.P0P2.PEGP.PO67 = One
                    }
                }

                Return (Zero)
            }

            If ((Arg0 == 0x05))
            {
                CreateWordField (Arg1, Zero, FN5S)
                CreateWordField (Arg1, 0x02, TGFX)
                TGXA = TGFX /* \_SB_.PCI0.GFX0.ATPX.TGFX */
                GSTP = One
                Return (Zero)
            }

            If ((Arg0 == 0x06))
            {
                CreateWordField (Arg1, Zero, FN6S)
                CreateWordField (Arg1, 0x02, AGFX)
                CMSI = 0x40
                Local1 = CMSD /* External reference */
                Local1 &= 0x02
                If ((AGFX == Zero))
                {
                    \_SB.PCI0.LPCB.EC0.DGPU = Zero
                    If (((\_SB.PCI0.WMID.BAEF == Zero) && (Local1 == Zero)))
                    {
                        If (((\_SB.PCI0.BAT1.POFT == One) && (\_SB.PCI0.LPCB.EC0.PSBB == Zero)))
                        {
                            \_SB.PCI0.BAT1.POFT = Zero
                            If ((\_SB.PCI0.LPCB.EC0.PSTA == One))
                            {
                                \_SB.PCI0.LPCB.EC0.PSTA = Zero
                            }

                            \_SB.PCI0.LPCB.EC0.CPOL (0x05)
                            \_SB.PCI0.LPCB.EC0.QEVN = One
                        }
                        Else
                        {
                            \_SB.PCI0.LPCB.EC0.PSBB = One
                        }
                    }
                    Else
                    {
                        \_SB.PCI0.BAT1.POFT = Zero
                    }
                }

                If ((AGFX == One))
                {
                    \_SB.PCI0.LPCB.EC0.DGPU = One
                    If (((\_SB.PCI0.WMID.BAEF == Zero) && (Local1 == Zero)))
                    {
                        If (((\_SB.PCI0.BAT1.POFT == One) && (\_SB.PCI0.LPCB.EC0.PSBB == One)))
                        {
                            \_SB.PCI0.BAT1.POFT = Zero
                            If ((\_SB.PCI0.LPCB.EC0.PSTA == One))
                            {
                                \_SB.PCI0.LPCB.EC0.PSTA = Zero
                            }

                            \_SB.PCI0.LPCB.EC0.CPOL (0x05)
                            \_SB.PCI0.LPCB.EC0.QEVN = One
                        }
                        Else
                        {
                            \_SB.PCI0.BAT1.POFT = Zero
                            \_SB.PCI0.LPCB.EC0.PSBB = Zero
                        }
                    }
                    Else
                    {
                        \_SB.PCI0.BAT1.POFT = Zero
                    }
                }

                If ((\_SB.PCI0.LPCB.EC0.FLAG == 0xFF))
                {
                    \_SB.PCI0.LPCB.EC0.FLAG = Zero
                }

                AGXA = AGFX /* \_SB_.PCI0.GFX0.ATPX.AGFX */
                GSTP = Zero
                Return (Zero)
            }

            If ((Arg0 == 0x08))
            {
                Name (TMP3, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP3, Zero, NOCN)
                CreateWordField (TMP3, 0x02, CNSS)
                NOCN = 0x0E
                CNSS = 0x46
                CreateByteField (TMP3, 0x04, FLG1)
                CreateByteField (TMP3, 0x05, ATI1)
                CreateByteField (TMP3, 0x06, ADI1)
                CreateWordField (TMP3, 0x07, ACP1)
                FLG1 = 0x07
                ATI1 = One
                ADI1 = Zero
                ACP1 = 0x0100
                CreateByteField (TMP3, 0x09, FLG2)
                CreateByteField (TMP3, 0x0A, ATI2)
                CreateByteField (TMP3, 0x0B, ADI2)
                CreateWordField (TMP3, 0x0C, ACP2)
                FLG2 = 0x07
                ATI2 = One
                ADI2 = One
                ACP2 = 0x0100
                CreateByteField (TMP3, 0x0E, FLG3)
                CreateByteField (TMP3, 0x0F, ATI3)
                CreateByteField (TMP3, 0x10, ADI3)
                CreateWordField (TMP3, 0x11, ACP3)
                FLG3 = 0x05
                ATI3 = Zero
                ADI3 = Zero
                ACP3 = 0x0400
                CreateByteField (TMP3, 0x13, FLG4)
                CreateByteField (TMP3, 0x14, ATI4)
                CreateByteField (TMP3, 0x15, ADI4)
                CreateWordField (TMP3, 0x16, ACP4)
                FLG4 = 0x05
                ATI4 = Zero
                ADI4 = One
                ACP4 = 0x0110
                CreateByteField (TMP3, 0x18, FLG5)
                CreateByteField (TMP3, 0x19, ATI5)
                CreateByteField (TMP3, 0x1A, ADI5)
                CreateWordField (TMP3, 0x1B, ACP5)
                FLG5 = 0x07
                ATI5 = 0x03
                ADI5 = Zero
                ACP5 = 0x0300
                CreateByteField (TMP3, 0x1D, FLG6)
                CreateByteField (TMP3, 0x1E, ATI6)
                CreateByteField (TMP3, 0x1F, ADI6)
                CreateWordField (TMP3, 0x20, ACP6)
                FLG6 = 0x07
                ATI6 = 0x03
                ADI6 = One
                ACP6 = 0x0210
                CreateByteField (TMP3, 0x22, FLG7)
                CreateByteField (TMP3, 0x23, ATI7)
                CreateByteField (TMP3, 0x24, ADI7)
                CreateWordField (TMP3, 0x25, ACP7)
                FLG7 = 0x07
                ATI7 = 0x07
                ADI7 = Zero
                ACP7 = 0x0301
                CreateByteField (TMP3, 0x27, FLG8)
                CreateByteField (TMP3, 0x28, ATI8)
                CreateByteField (TMP3, 0x29, ADI8)
                CreateWordField (TMP3, 0x2A, ACP8)
                FLG8 = 0x07
                ATI8 = 0x07
                ADI8 = One
                ACP8 = 0x0220
                CreateByteField (TMP3, 0x2C, FLG9)
                CreateByteField (TMP3, 0x2D, ATI9)
                CreateByteField (TMP3, 0x2E, ADI9)
                CreateWordField (TMP3, 0x2F, ACP9)
                FLG9 = 0x07
                ATI9 = 0x09
                ADI9 = Zero
                ACP9 = 0x0302
                CreateByteField (TMP3, 0x31, FLGA)
                CreateByteField (TMP3, 0x32, ATIA)
                CreateByteField (TMP3, 0x33, ADIA)
                CreateWordField (TMP3, 0x34, ACPA)
                FLGA = 0x07
                ATIA = 0x09
                ADIA = One
                ACPA = 0x0230
                CreateByteField (TMP3, 0x36, FLGB)
                CreateByteField (TMP3, 0x37, ATIB)
                CreateByteField (TMP3, 0x38, ADIB)
                CreateWordField (TMP3, 0x39, ACPB)
                FLGB = 0x07
                ATIB = 0x0A
                ADIB = Zero
                ACPB = 0x0303
                CreateByteField (TMP3, 0x3B, FLGC)
                CreateByteField (TMP3, 0x3C, ATIC)
                CreateByteField (TMP3, 0x3D, ADIC)
                CreateWordField (TMP3, 0x3E, ACPC)
                FLGC = 0x07
                ATIC = 0x0A
                ADIC = One
                ACPC = 0x0240
                CreateByteField (TMP3, 0x40, FLGD)
                CreateByteField (TMP3, 0x41, ATID)
                CreateByteField (TMP3, 0x42, ADID)
                CreateWordField (TMP3, 0x43, ACPD)
                FLGD = 0x07
                ATID = 0x0B
                ADID = Zero
                ACPD = 0x0304
                CreateByteField (TMP3, 0x45, FLGE)
                CreateByteField (TMP3, 0x46, ATIE)
                CreateByteField (TMP3, 0x47, ADIE)
                CreateWordField (TMP3, 0x48, ACPE)
                FLGE = 0x07
                ATIE = 0x0B
                ADIE = One
                ACPE = 0x0250
                Return (TMP3) /* \_SB_.PCI0.GFX0.ATPX.TMP3 */
            }

            Return (Zero)
        }

        Method (ATRM, 2, Serialized)
        {
            Local0 = Arg0
            Local1 = Arg1
            If ((Local1 > 0x1000))
            {
                Local1 = 0x1000
            }

            If ((Local0 > 0x00010000))
            {
                Return (Buffer (Local1)
                {
                     0x00                                             /* . */
                })
            }

            If ((Local0 > RVBS))
            {
                Return (Buffer (Local1)
                {
                     0x00                                             /* . */
                })
            }

            Local3 = (Local1 * 0x08)
            Name (ROM1, Buffer (0x8000)
            {
                 0x00                                             /* . */
            })
            Name (ROM2, Buffer (Local1)
            {
                 0x00                                             /* . */
            })
            If ((Local0 < 0x8000))
            {
                ROM1 = RBF1 /* \_SB_.PCI0.GFX0.RBF1 */
            }
            Else
            {
                Local0 -= 0x8000
                ROM1 = RBF2 /* \_SB_.PCI0.GFX0.RBF2 */
            }

            Local2 = (Local0 * 0x08)
            CreateField (ROM1, Local2, Local3, TMPB)
            ROM2 = TMPB /* \_SB_.PCI0.GFX0.ATRM.TMPB */
            Return (ROM2) /* \_SB_.PCI0.GFX0.ATRM.ROM2 */
        }
    }

    Method (IDAB, 0, Serialized)
    {
        DID1 = 0x80010100
        DID2 = 0x80010400
        DID3 = 0x80010300
        DID4 = 0x80010301
        DID5 = 0x80010302
        DID6 = 0x80010303
        DID7 = 0x80010304
        NDID = 0x07
    }

    Method (HGAS, 0, Serialized)
    {
        If (PWRS)
        {
            \_SB.PCI0.GFX0.SPWS = One
        }
        Else
        {
            \_SB.PCI0.GFX0.SPWS = 0x02
        }

        If ((\_SB.PCI0.GFX0.GSTP != One))
        {
            \_SB.PCI0.GFX0.SPSR = One
            Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
        }
    }

    Method (HBRT, 1, Serialized)
    {
        If ((0x04 & DSEN))
        {
            If ((Arg0 == 0x04))
            {
                Notify (\_SB.PCI0.P0P2.PEGP.DD02, 0x87) // Device-Specific
            }

            If ((Arg0 == 0x03))
            {
                Notify (\_SB.PCI0.P0P2.PEGP.DD02, 0x86) // Device-Specific
            }
        }
    }

    Method (HLSE, 0, Serialized)
    {
        If ((\_SB.PCI0.GFX0.GSTP != One))
        {
            If ((\_SB.PCI0.GFX0.AGXA == Zero))
            {
                \_SB.PCI0.GFX0.GLID (LIDS ())
            }
        }
    }

    Method (HDSE, 1, Serialized)
    {
        If ((\_SB.PCI0.GFX0.GSTP != One))
        {
            If ((\_SB.PCI0.GFX0.AGXA == Zero))
            {
                \_SB.PCI0.GFX0.GHDS (Arg0)
            }
            Else
            {
                \_SB.PCI0.GFX0.DSWR = One
                \_SB.PCI0.GFX0.TLST = (\_SB.PCI0.LPCB.H_EC.SCAN - 0x3A)
                Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
            }
        }
    }

    Method (HPFS, 0, Serialized)
    {
        If ((\_SB.PCI0.GFX0.GSTP != One))
        {
            If ((\_SB.PCI0.GFX0.AGXA == Zero))
            {
                \_SB.PCI0.GFX0.AINT (0x02, Zero)
            }
            Else
            {
                \_SB.PCI0.GFX0.EMDR = One
                If ((\_SB.PCI0.GFX0.EXPM == 0x02))
                {
                    \_SB.PCI0.GFX0.EXPM = Zero
                }
                Else
                {
                    \_SB.PCI0.GFX0.EXPM++
                }

                Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
            }
        }
    }

    Method (HGLS, 0, Serialized)
    {
        If ((\_SB.PCI0.GFX0.GSTP != One))
        {
            If ((\_SB.PCI0.GFX0.AGXA == Zero))
            {
                If (\_SB.PCI0.GFX0.GLID (LIDS ()))
                {
                    \_SB.PCI0.GFX0.CLID |= 0x80000000 /* External reference */
                }
            }
        }
    }

    Method (FPED, 0, NotSerialized)
    {
        OperationRegion (IGDM, SystemMemory, ASLB (0x2000), Field (IGDM, AnyAcc, NoLock, Preserve)
            {
                Offset (0x1C04), 
                DDCH,   1024
            })
    }

    Method (PDCC, 0, NotSerialized)
    {
        \_SB.PCI0.GFX0.DCFR = One
        Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
    }

    Method (PXPW, 0, Serialized)
    {
        If (PWRS)
        {
            \_SB.PCI0.GFX0.SPWS = One
        }
        Else
        {
            \_SB.PCI0.GFX0.SPWS = 0x02
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (COTA, 1, NotSerialized)
        {
            If ((NTLE != Zero))
            {
                If ((TLE1 == Arg0))
                {
                    Return (One)
                }

                If ((TLE2 == Arg0))
                {
                    Return (0x02)
                }

                If ((TLE3 == Arg0))
                {
                    Return (0x03)
                }

                If ((TLE4 == Arg0))
                {
                    Return (0x04)
                }

                If ((TLE5 == Arg0))
                {
                    Return (0x05)
                }

                If ((TLE6 == Arg0))
                {
                    Return (0x06)
                }

                If ((TLE7 == Arg0))
                {
                    Return (0x07)
                }

                If ((TLE8 == Arg0))
                {
                    Return (0x08)
                }

                If ((TLE9 == Arg0))
                {
                    Return (0x09)
                }

                If ((TL10 == Arg0))
                {
                    Return (0x0A)
                }

                If ((TL11 == Arg0))
                {
                    Return (0x0B)
                }

                If ((TL12 == Arg0))
                {
                    Return (0x0C)
                }

                If ((TL13 == Arg0))
                {
                    Return (0x0D)
                }

                If ((TL14 == Arg0))
                {
                    Return (0x0E)
                }

                If ((TL15 == Arg0))
                {
                    Return (0x0F)
                }
            }

            Return (Zero)
        }

        Method (NATL, 1, NotSerialized)
        {
            If ((NTLE != Zero))
            {
                If ((Arg0 == One))
                {
                    Return (TLE2) /* \_SB_.PCI0.GFX0.TLE2 */
                }

                If ((Arg0 == 0x02))
                {
                    Return (TLE3) /* \_SB_.PCI0.GFX0.TLE3 */
                }

                If ((Arg0 == 0x03))
                {
                    Return (TLE4) /* \_SB_.PCI0.GFX0.TLE4 */
                }

                If ((Arg0 == 0x04))
                {
                    Return (TLE5) /* \_SB_.PCI0.GFX0.TLE5 */
                }

                If ((Arg0 == 0x05))
                {
                    Return (TLE6) /* \_SB_.PCI0.GFX0.TLE6 */
                }

                If ((Arg0 == 0x06))
                {
                    Return (TLE7) /* \_SB_.PCI0.GFX0.TLE7 */
                }

                If ((Arg0 == 0x07))
                {
                    Return (TLE8) /* \_SB_.PCI0.GFX0.TLE8 */
                }

                If ((Arg0 == 0x08))
                {
                    Return (TLE9) /* \_SB_.PCI0.GFX0.TLE9 */
                }

                If ((Arg0 == 0x09))
                {
                    Return (TL10) /* \_SB_.PCI0.GFX0.TL10 */
                }

                If ((Arg0 == 0x0A))
                {
                    Return (TL11) /* \_SB_.PCI0.GFX0.TL11 */
                }

                If ((Arg0 == 0x0B))
                {
                    Return (TL12) /* \_SB_.PCI0.GFX0.TL12 */
                }

                If ((Arg0 == 0x0C))
                {
                    Return (TL13) /* \_SB_.PCI0.GFX0.TL13 */
                }

                If ((Arg0 == 0x0D))
                {
                    Return (TL14) /* \_SB_.PCI0.GFX0.TL14 */
                }

                If ((Arg0 == 0x0E))
                {
                    Return (TL15) /* \_SB_.PCI0.GFX0.TL15 */
                }

                If ((Arg0 == 0x0F))
                {
                    Return (TLE1) /* \_SB_.PCI0.GFX0.TLE1 */
                }
            }

            Return (Zero)
        }

        Name (ATIB, Buffer (0x0100) {})
        Method (ATIF, 2, Serialized)
        {
            If ((Arg0 == Zero))
            {
                Return (AF00 ())
            }

            If ((Arg0 == One))
            {
                Return (AF01 ())
            }

            If ((Arg0 == 0x02))
            {
                Return (AF02 ())
            }

            If ((Arg0 == 0x03))
            {
                Return (AF03 (DerefOf (Arg1 [0x02]), DerefOf (Arg1 [0x04])))
            }
            Else
            {
                CreateWordField (ATIB, Zero, SSZE)
                CreateWordField (ATIB, 0x02, VERN)
                CreateDWordField (ATIB, 0x04, NMSK)
                CreateDWordField (ATIB, 0x08, SFUN)
                SSZE = Zero
                VERN = Zero
                NMSK = Zero
                SFUN = Zero
                Return (ATIB) /* \_SB_.PCI0.GFX0.ATIB */
            }
        }

        Method (AF00, 0, NotSerialized)
        {
            CreateWordField (ATIB, Zero, SSZE)
            CreateWordField (ATIB, 0x02, VERN)
            CreateDWordField (ATIB, 0x04, NMSK)
            CreateDWordField (ATIB, 0x08, SFUN)
            SSZE = 0x0C
            VERN = One
            NMSK = 0x51
            MSKN = NMSK /* \_SB_.PCI0.GFX0.AF00.NMSK */
            SFUN = 0x07
            Return (ATIB) /* \_SB_.PCI0.GFX0.ATIB */
        }

        Name (NCOD, 0x81)
        Method (AF01, 0, NotSerialized)
        {
            CreateWordField (ATIB, Zero, SSZE)
            CreateDWordField (ATIB, 0x02, VMSK)
            CreateDWordField (ATIB, 0x06, FLGS)
            VMSK = 0x03
            SSZE = 0x0A
            FLGS = One
            NCOD = 0x81
            Return (ATIB) /* \_SB_.PCI0.GFX0.ATIB */
        }

        Name (PSBR, Buffer (0x04)
        {
             0x00, 0x00, 0x00, 0x00                           /* .... */
        })
        Name (MSKN, Zero)
        Name (SEXM, Zero)
        Name (STHG, Zero)
        Name (STHI, Zero)
        Name (SFPG, Zero)
        Name (SFPI, Zero)
        Name (SSPS, Zero)
        Name (SSDM, 0x0A)
        Name (SCDY, Zero)
        Name (SACT, Buffer (0x06)
        {
             0x01, 0x02, 0x08, 0x03, 0x09, 0x0A               /* ...... */
        })
        Method (AF02, 0, NotSerialized)
        {
            CreateBitField (PSBR, Zero, PDSW)
            CreateBitField (PSBR, One, PEXM)
            CreateBitField (PSBR, 0x02, PTHR)
            CreateBitField (PSBR, 0x03, PFPS)
            CreateBitField (PSBR, 0x04, PSPS)
            CreateBitField (PSBR, 0x05, PDCC)
            CreateBitField (PSBR, 0x06, PXPS)
            CreateWordField (ATIB, Zero, SSZE)
            CreateDWordField (ATIB, 0x02, PSBI)
            CreateByteField (ATIB, 0x06, EXPM)
            CreateByteField (ATIB, 0x07, THRM)
            CreateByteField (ATIB, 0x08, THID)
            CreateByteField (ATIB, 0x09, FPWR)
            CreateByteField (ATIB, 0x0A, FPID)
            CreateByteField (ATIB, 0x0B, SPWR)
            SSZE = 0x0C
            PSBI = PSBR /* \_SB_.PCI0.GFX0.PSBR */
            If (PDSW)
            {
                PDSW = Zero
            }

            If (PEXM)
            {
                EXPM = SEXM /* \_SB_.PCI0.GFX0.SEXM */
                SEXM = Zero
                PEXM = Zero
            }

            If (PTHR)
            {
                THRM = STHG /* \_SB_.PCI0.GFX0.STHG */
                THID = STHI /* \_SB_.PCI0.GFX0.STHI */
                STHG = Zero
                STHI = Zero
                PTHR = Zero
            }

            If (PFPS)
            {
                FPWR = SFPG /* \_SB_.PCI0.GFX0.SFPG */
                FPWR = SFPI /* \_SB_.PCI0.GFX0.SFPI */
                SFPG = Zero
                SFPI = Zero
                PFPS = Zero
            }

            If (PSPS)
            {
                SPWR = SSPS /* \_SB_.PCI0.GFX0.SSPS */
                PSPS = Zero
            }

            If (PXPS)
            {
                PXPS = Zero
            }

            Return (ATIB) /* \_SB_.PCI0.GFX0.ATIB */
        }

        Method (AF03, 2, NotSerialized)
        {
            CreateWordField (ATIB, Zero, SSZE)
            CreateWordField (ATIB, 0x02, SSDP)
            CreateWordField (ATIB, 0x04, SCDP)
            SSDP = Arg0
            SCDP = Arg1
            Name (NXTD, 0x06)
            Name (CIDX, 0x06)
            Local1 = SSDP /* \_SB_.PCI0.GFX0.AF03.SSDP */
            Local1 &= 0x0B
            Local2 = SCDP /* \_SB_.PCI0.GFX0.AF03.SCDP */
            If (CondRefOf (\_SB.LID0._LID, Local4))
            {
                Local2 &= 0xFFFFFFFE
                Local2 |= \_SB.LID0._LID /* External reference */
            }
            Else
            {
                Local2 |= One
            }

            Local0 = Zero
            While ((Local0 < SizeOf (SACT)))
            {
                Local3 = DerefOf (SACT [Local0])
                If ((Local3 == Local1))
                {
                    CIDX = Local0
                    Local0 = SizeOf (SACT)
                }
                Else
                {
                    Local0++
                }
            }

            Local0 = CIDX /* \_SB_.PCI0.GFX0.AF03.CIDX */
            While ((Local0 < SizeOf (SACT)))
            {
                Local0++
                If ((Local0 == SizeOf (SACT)))
                {
                    Local0 = Zero
                }

                Local3 = DerefOf (SACT [Local0])
                If (((Local3 & Local2) == Local3))
                {
                    NXTD = Local0
                    Local0 = SizeOf (SACT)
                }
            }

            If ((NXTD == SizeOf (SACT)))
            {
                SSDP = Zero
            }
            Else
            {
                Local0 = NXTD /* \_SB_.PCI0.GFX0.AF03.NXTD */
                Local3 = DerefOf (SACT [Local0])
                SSDP &= 0xFFFFFFF4
                SSDP |= Local3
            }

            SSZE = 0x04
            Return (ATIB) /* \_SB_.PCI0.GFX0.ATIB */
        }

        Method (AFN0, 0, Serialized)
        {
            If ((MSKN & One))
            {
                CreateBitField (PSBR, Zero, PDSW)
                PDSW = One
                Notify (GFX0, NCOD)
            }
        }

        Method (AFN3, 2, Serialized)
        {
            If ((MSKN & 0x08))
            {
                Local0 = Arg0
                SFPI = Local0
                Local0 = Arg1
                SFPG = Local0 &= 0x03
                CreateBitField (PSBR, 0x03, PFPS)
                PFPS = One
                Notify (GFX0, NCOD)
            }
        }

        Method (AFN4, 1, Serialized)
        {
            If ((MSKN & 0x10))
            {
                Local0 = Arg0
                Local1 = SSPS /* \_SB_.PCI0.GFX0.SSPS */
                SSPS = Local0
                If ((Local0 == Local1)) {}
                Else
                {
                    CreateBitField (PSBR, 0x04, PSPS)
                    PSPS = One
                    Notify (GFX0, NCOD)
                }
            }
        }

        Method (AFN5, 0, Serialized)
        {
            If ((MSKN & 0x20))
            {
                CreateBitField (PSBR, 0x05, PDCC)
                PDCC () = One
                Notify (GFX0, NCOD)
            }
        }

        Method (AFN6, 0, Serialized)
        {
            If ((MSKN & 0x40))
            {
                CreateBitField (PSBR, 0x06, PXPS)
                PXPS = One
                Notify (GFX0, NCOD)
            }
        }
    }

    Scope (\_SB.PCI0.P0P2)
    {
        Name (B0D1, Zero)
        OperationRegion (RPCI, SystemMemory, 0x1000 = (PEBS (0x8000) | B0D1) /* \_SB_.PCI0.P0P2.B0D1 */, Field (RPCI, DWordAcc, Lock, Preserve)
            {
                Offset (0xB0), 
                ASPM,   2, 
                    ,   2, 
                LNKD,   1, 
                Offset (0x1FC), 
                    ,   9, 
                UDAP,   1, 
                Offset (0x214), 
                Offset (0x216), 
                LNKS,   4, 
                Offset (0x224), 
                Offset (0x225), 
                DQDA,   1, 
                Offset (0xC28), 
                HCLQ,   1, 
                Offset (0xC34), 
                    ,   30, 
                PEDQ,   1, 
                PIDQ,   1, 
                Offset (0xDFC), 
                PEPO,   3, 
                Offset (0xE08), 
                    ,   31, 
                ROE0,   1, 
                Offset (0xE28), 
                    ,   31, 
                ROE1,   1, 
                Offset (0xE48), 
                    ,   31, 
                ROE2,   1, 
                Offset (0xE68), 
                    ,   31, 
                ROE3,   1, 
                Offset (0xE88), 
                    ,   31, 
                ROE4,   1, 
                Offset (0xEA8), 
                    ,   31, 
                ROE5,   1, 
                Offset (0xEC8), 
                    ,   31, 
                ROE6,   1, 
                Offset (0xEE8), 
                    ,   31, 
                ROE7,   1, 
                Offset (0xF08), 
                    ,   31, 
                ROE8,   1, 
                Offset (0xF28), 
                    ,   31, 
                ROE9,   1, 
                Offset (0xF48), 
                    ,   31, 
                ROEA,   1, 
                Offset (0xF68), 
                    ,   31, 
                ROEB,   1, 
                Offset (0xF88), 
                    ,   31, 
                ROEC,   1, 
                Offset (0xFA8), 
                    ,   31, 
                ROED,   1, 
                Offset (0xFC8), 
                    ,   31, 
                ROEE,   1, 
                Offset (0xFE8), 
                    ,   31, 
                ROEF,   1
            })
        OperationRegion (DMIB, SystemMemory, 0xFED18000, 0x1000)
        Field (DMIB, DWordAcc, Lock, Preserve)
        {
            Offset (0xC34), 
            LLGE,   1, 
                ,   28, 
            PCGE,   1, 
                ,   1, 
            LGGE,   1
        }

        Device (PEGA)
        {
            Name (_ADR, One)  // _ADR: Address
            Name (_PRW, Package (0x02)  // _PRW: Power Resources for Wake
            {
                0x09, 
                0x04
            })
            OperationRegion (PEAU, PCI_Config, Zero, 0xFF)
            Field (PEAU, ByteAcc, NoLock, Preserve)
            {
                Offset (0x4C), 
                SSID,   32
            }
        }
    }

    Scope (\_SB.PCI0)
    {
        OperationRegion (RPCI, SystemMemory, PEBS (0x0100), Field (RPCI, DWordAcc, Lock, Preserve)
            {
                Offset (0x54), 
                    ,   1, 
                D1EN,   1
            })
    }

    Scope (\_SB.PCI0.P0P2.PEGP)
    {
        OperationRegion (PCIS, SystemMemory, EBAS (0x0100), Field (PCIS, DWordAcc, Lock, Preserve)
            {
                Offset (0x4C), 
                SSID,   32
            })
        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            \_SB.PCI0.P0P2.PEGP._ADR = Zero
        }

        Name (VSID, Zero)
        Method (_ON, 0, Serialized)  // _ON_: Power On
        {
            If ((\_SB.PCI0.D1EN == Zero))
            {
                D1EN = One
                Sleep (0xC8)
                Notify (\_SB.PCI0, Zero) // Bus Check
            }

            If (Ones)
            {
                \_SB.PCI0.P0P2.PEGP.PO16 = Zero
            }
            Else
            {
                \_SB.PCI0.P0P2.PEGP.PO16 = One
            }

            Sleep (0x64)
            If (Ones)
            {
                \_SB.PCI0.P0P2.PEGP.PO36 = Zero
            }
            Else
            {
                \_SB.PCI0.P0P2.PEGP.PO36 = One
            }

            Sleep (0x64)
            PO35 = One
            Sleep (0x012C)
            If (Zero)
            {
                \_SB.PCI0.P0P2.PEGP.PO16 = Zero
            }
            Else
            {
                \_SB.PCI0.P0P2.PEGP.PO16 = One
            }

            Sleep (0x64)
            LLGE = Zero
            LGGE = Zero
            PEPO = Zero
            ROE0 = Zero
            ROE1 = Zero
            ROE2 = Zero
            ROE3 = Zero
            ROE4 = Zero
            ROE5 = Zero
            ROE6 = Zero
            ROE7 = Zero
            ROE8 = Zero
            ROE9 = Zero
            ROEA = Zero
            ROEB = Zero
            ROEC = Zero
            ROED = Zero
            ROEE = Zero
            ROEF = Zero
            HCLQ = Zero
            UDAP = Zero
            PEDQ = Zero
            LNKD = Zero
            LLGE = One
            LGGE = One
            While ((LNKS < 0x07))
            {
                Sleep (One)
            }

            SSID = VSID /* \_SB_.PCI0.P0P2.PEGP.VSID */
            \_SB.PCI0.P0P2.PEGA.SSID = VSID /* \_SB_.PCI0.P0P2.PEGP.VSID */
            Notify (\_SB.PCI0.P0P2, Zero) // Bus Check
        }

        Method (_OFF, 0, Serialized)  // _OFF: Power Off
        {
            VSID = SSID /* \_SB_.PCI0.P0P2.PEGP.SSID */
            LLGE = Zero
            LGGE = Zero
            LNKD = One
            While ((LNKS != Zero))
            {
                Sleep (One)
            }

            PEDQ = One
            LNKD = Zero
            While ((PIDQ != One))
            {
                Sleep (One)
            }

            HCLQ = One
            UDAP = One
            PEPO = 0x07
            ROE0 = One
            ROE1 = One
            ROE2 = One
            ROE3 = One
            ROE4 = One
            ROE5 = One
            ROE6 = One
            ROE7 = One
            ROE8 = One
            ROE9 = One
            ROEA = One
            ROEB = One
            ROEC = One
            ROED = One
            ROEE = One
            ROEF = One
            LLGE = One
            LGGE = One
            If (Ones)
            {
                \_SB.PCI0.P0P2.PEGP.PO16 = Zero
            }
            Else
            {
                \_SB.PCI0.P0P2.PEGP.PO16 = One
            }

            Sleep (0x64)
            PO35 = Zero
            Sleep (0x012C)
            If (Zero)
            {
                \_SB.PCI0.P0P2.PEGP.PO36 = Zero
            }
            Else
            {
                \_SB.PCI0.P0P2.PEGP.PO36 = One
            }

            If ((\_SB.PCI0.D1EN == One))
            {
                D1EN = Zero
                Sleep (0xC8)
                Notify (\_SB.PCI0, Zero) // Bus Check
            }

            Notify (\_SB.PCI0.P0P2, Zero) // Bus Check
        }

        Method (_STA, 0, Serialized)  // _STA: Status
        {
            If (Ones)
            {
                If ((\_SB.PCI0.P0P2.PEGP.PO36 == Zero))
                {
                    Return (0x0F)
                }
            }
            ElseIf ((\_SB.PCI0.P0P2.PEGP.PO36 == One))
            {
                Return (0x0F)
            }

            Return (Zero)
        }

        Method (_DOD, 0, NotSerialized)  // _DOD: Display Output Devices
        {
            Return (\_SB.PCI0.GFX0._DOD) /* External reference */
        }

        Device (DD01)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD01._ADR) /* External reference */
            }
        }

        Device (DD02)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD02._ADR) /* External reference */
            }

            Method (_BCL, 0, NotSerialized)  // _BCL: Brightness Control Levels
            {
                Return (\_SB.PCI0.GFX0.DD02._BCL) /* External reference */
            }

            Method (_BQC, 0, NotSerialized)  // _BQC: Brightness Query Current
            {
                Return (\_SB.PCI0.GFX0.DD02._BQC) /* External reference */
            }

            Method (_BCM, 1, NotSerialized)  // _BCM: Brightness Control Method
            {
                Return (\_SB.PCI0.GFX0.DD02._BCM) /* External reference */
                Arg0
            }
        }

        Device (DD03)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD03._ADR) /* External reference */
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD04._ADR) /* External reference */
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD05._ADR) /* External reference */
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD06._ADR) /* External reference */
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD07._ADR) /* External reference */
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (\_SB.PCI0.GFX0.DD08._ADR) /* External reference */
            }
        }
    }
}

